LOAD_TILES:
	LDA	#$13
	STA	RAM_BANK
	LDA	#9	;LENGTH OF FILENAME
	LDX	#<TILENAME
	LDY	#>TILENAME
	JSR	$FFBD	;SETNAM A=FILE NAME LENGTH X/Y=POINTER TO FILENAME
	LDA	#$02
	LDX	#$08
	LDY	#$02
	JSR	$FFBA	;SETFLS A=LOGICAL NUMBER X=DEVICE NUMBER Y=SECONDARY
	LDX	#$00	;LOW BYTE FOR LOAD ADDRESS
	LDY	#$A0	;HIGH BYTE FOR LOAD ADDRESS
	LDA	#$00
	JSR	$FFD5	;LOAD FILE A=0 FOR LOAD X/Y=LOAD ADDRESS
	LDA	#$02
	JSR	$FFC3	;CLOSE FILE
	RTS
TILENAME  !PET"tiles.bin"

LOAD_MAP:
	LDA	#7	;LENGTH OF FILENAME
	LDX	#<MAPNAME
	LDY	#>MAPNAME
	JSR	$FFBD	;SETNAM A=FILE NAME LENGTH X/Y=POINTER TO FILENAME
	LDA	#$02
	LDX	#$08
	LDY	#$00
	JSR	$FFBA	;SETFLS A=LOGICAL NUMBER X=DEVICE NUMBER Y=SECONDARY
	LDX	#$00	;LOW BYTE FOR LOAD ADDRESS
	LDY	#$7D	;HIGH BYTE FOR LOAD ADDRESS
	LDA	#$00	;0=load into base RAM
	JSR	$FFD5	;LOAD FILE A=0 FOR LOAD X/Y=LOAD ADDRESS
	JSR	$FFC3	;CLOSE FILE
	RTS

LOAD_TITLE_SCREEN:
	LDA	#9	;filename-length
	LDX	#<TITLEBM_FILENAME
	LDY	#>TITLEBM_FILENAME
	JSR	$FFBD	;SETNAM A=FILE NAME LENGTH X/Y=POINTER TO FILENAME
	LDA	#$02
	LDX	#$08
	LDY	#$02
	JSR	$FFBA	;SETFLS A=LOGICAL NUMBER X=DEVICE NUMBER Y=SECONDARY
	LDX	#$00
	LDY	#$20	;load into $0,2000 VRAM
	LDA	#$02
	JSR	$FFD5	;LOAD FILE A=0 FOR LOAD X/Y=LOAD ADDRESS
	LDA	#$02	;2=VRAM BANK 0, 3=VRAM BANK 1
	JSR	$FFC3	;CLOSE FILE
	RTS
TITLEBM_FILENAME	!PET"title.bin"

LOAD_GAMEUI_SCREEN:
	LDA	#10	;filename-length
	LDX	#<GAMEUI_FILENAME
	LDY	#>GAMEUI_FILENAME
	JSR	$FFBD	;SETNAM A=FILE NAME LENGTH X/Y=POINTER TO FILENAME
	LDA	#$02
	LDX	#$08
	LDY	#$02
	JSR	$FFBA	;SETFLS A=LOGICAL NUMBER X=DEVICE NUMBER Y=SECONDARY
	LDX	#$00
	LDY	#$20	;load into $0,2000 VRAM
	LDA	#$02	;2=VRAM BANK 0, 3=VRAM BANK 1
	JSR	$FFD5	;LOAD FILE A=0 FOR LOAD X/Y=LOAD ADDRESS
	LDA	#$02
	JSR	$FFC3	;CLOSE FILE
	RTS
GAMEUI_FILENAME	!PET"gameui.bin"

LOAD_SPRITES:
	LDA	#11	;filename-length
	LDX	#<SPRITES_FILENAME
	LDY	#>SPRITES_FILENAME
	JSR	$FFBD	;SETNAM A=FILE NAME LENGTH X/Y=POINTER TO FILENAME
	LDA	#$02
	LDX	#$08
	LDY	#$02
	JSR	$FFBA	;SETFLS A=LOGICAL NUMBER X=DEVICE NUMBER Y=SECONDARY
	LDX	#$00
	LDY	#$00	;load into $1,0000 VRAM
	LDA	#$03	;2=VRAM BANK 0, 3=VRAM BANK 1
	JSR	$FFD5	;LOAD FILE A=0 FOR LOAD X/Y=LOAD ADDRESS
	LDA	#$02
	JSR	$FFC3	;CLOSE FILE
	RTS
SPRITES_FILENAME	!PET"sprites.bin"

LOAD_WI_SPRITES:
	LDA	#10	;filename-length
	LDX	#<WI_FILENAME
	LDY	#>WI_FILENAME
	JSR	$FFBD	;SETNAM A=FILE NAME LENGTH X/Y=POINTER TO FILENAME
	LDA	#$02
	LDX	#$08
	LDY	#$02
	JSR	$FFBA	;SETFLS A=LOGICAL NUMBER X=DEVICE NUMBER Y=SECONDARY
	LDX	#$00
	LDY	#$E0	;load into $0,E000 VRAM
	LDA	#$02	;2=VRAM BANK 0, 3=VRAM BANK 1
	JSR	$FFD5	;LOAD FILE A=0 FOR LOAD X/Y=LOAD ADDRESS
	LDA	#$02
	JSR	$FFC3	;CLOSE FILE
	RTS
WI_FILENAME	!PET"widata.bin"

LOAD_FONT:
	LDA	#11	;filename-length
	LDX	#<FONT_FILENAME
	LDY	#>FONT_FILENAME
	JSR	$FFBD	;SETNAM A=FILE NAME LENGTH X/Y=POINTER TO FILENAME
	LDA	#$02
	LDX	#$08
	LDY	#$02
	JSR	$FFBA	;SETFLS A=LOGICAL NUMBER X=DEVICE NUMBER Y=SECONDARY
	LDX	#$00
	LDY	#$F8	;load into $1,0000 VRAM
	LDA	#$02	;2=VRAM BANK 0, 3=VRAM BANK 1
	JSR	$FFD5	;LOAD FILE A=0 FOR LOAD X/Y=LOAD ADDRESS
	LDA	#$02
	JSR	$FFC3	;CLOSE FILE
	RTS
FONT_FILENAME	!PET"gfxfont.bin"

LOAD_SFX:	;sound FX samples load in at bank 1, $A000
	LDA	#1
	STA	RAM_BANK
	LDA	#07	;filename-length
	LDX	#<PCM_FILENAME
	LDY	#>PCM_FILENAME
	JSR	$FFBD	;SETNAM A=FILE NAME LENGTH X/Y=POINTER TO FILENAME
	LDA	#$02
	LDX	#$08
	LDY	#$02
	JSR	$FFBA	;SETFLS A=LOGICAL NUMBER X=DEVICE NUMBER Y=SECONDARY
	LDX	#$00
	LDY	#$A0	;load into $A000
	LDA	#$00
	JSR	$FFD5	;LOAD FILE A=0 FOR LOAD X/Y=LOAD ADDRESS
	LDA	#$02
	JSR	$FFC3	;CLOSE FILE
	RTS
PCM_FILENAME	!PET"sfx.bin"

LOAD_MUSIC:	;sound FX samples load in at bank 1, $A000
	LDA	SONG
	CLC
	ADC	#48	;char code for zero
	STA	MUSIC_FILENAME+5
	LDA	#$1D
	STA	RAM_BANK
	LDA	#10	;filename-length
	LDX	#<MUSIC_FILENAME
	LDY	#>MUSIC_FILENAME
	JSR	$FFBD	;SETNAM A=FILE NAME LENGTH X/Y=POINTER TO FILENAME
	LDA	#$02
	LDX	#$08
	LDY	#$02
	JSR	$FFBA	;SETFLS A=LOGICAL NUMBER X=DEVICE NUMBER Y=SECONDARY
	LDX	#$00
	LDY	#$A0	;load into $A000
	LDA	#$00
	JSR	$FFD5	;LOAD FILE A=0 FOR LOAD X/Y=LOAD ADDRESS
	LDA	#$02
	JSR	$FFC3	;CLOSE FILE
	RTS
MUSIC_FILENAME	!PET"music0.zsm"