INTRO_SCREEN:
	JSR	DISPLAY_INTRO_SCREEN
	JSR	CHANGE_DIFFICULTY_LEVEL
	JSR	DISPLAY_MAP_NAME
	JSR 	START_INTRO_SCREEN_MUSIC
	LDA	#0
	STA	MENUY
ISLOOP:	JSR	UPDATE_MENU_FLASH
	;FIRST CHECK SNES CONTROLLER
	JSR	SNES_CONTROLER_READ
	LDA	NEW_UP
	CMP	#1
	BNE	ISS1
	LDA	#0
	STA	NEW_UP
	LDA	#$91	;CURSOR_UP
	JMP	ISS9
ISS1:	LDA	NEW_DOWN
	CMP	#1
	BNE	ISS2
	LDA	#0
	STA	NEW_DOWN
	LDA	#$11	;CURSOR_DOWN
	JMP	ISS9
ISS2:	LDA	NEW_B
	CMP	#1
	BNE	ISS3	
	LDA	#2		;SET SNES PAD TO CURRENT CONTROL
	STA	CONTROL		;SINCE USER IS CLEARLY USING IT.
	LDA	#0
	STA	NEW_B
	LDA	#13	;RETURN
	JMP	ISS9
	;NOW CHECK KEYBOARD
ISS3:	JSR	$FFE4
ISS9:	CMP	#00
	BEQ	ISLOOP
	CMP	#$11	;CURSOR DOWN
	BNE	IS001
IS001A:	LDA	MENUY
	CMP	#3
	BEQ	ISLOOP
	LDA	#$05
	STA	MENUCOL
	JSR	FLASH_MENU_OPTION
	INC	MENUY
	LDA	#0		;menu beep
	JSR	PLAY_DIGI_SOUND	;SOUND PLAY
	JMP	ISLOOP
IS001:	CMP	#$91	;CURSOR UP
	BNE	IS002
IS002A:	LDA	MENUY
	CMP	#0
	BEQ	ISLOOP
	LDA	#$05
	STA	MENUCOL
	JSR	FLASH_MENU_OPTION
	DEC	MENUY
	LDA	#0		;menu beep
	JSR	PLAY_DIGI_SOUND	;SOUND PLAY
	JMP	ISLOOP
IS002:	CMP	#32	;SPACE
	BNE	IS003
	JMP	EXEC_COMMAND
IS003:	CMP	KEY_MOVE_UP
	BNE	IS004
	JMP	IS002A
IS004:	CMP	KEY_MOVE_DOWN
	BNE	IS005
	JMP	IS001A
IS005:	CMP	#13	;RETURN
	BNE	IS006
	JMP	EXEC_COMMAND
IS006:	JMP	ISLOOP

EXEC_COMMAND:
	LDA	#1		;SHORT BEEP
	JSR	PLAY_DIGI_SOUND	;SOUND PLAY
	LDA	MENUY
	CMP	#00	;START GAME
	BNE	EXEC1
	JSR	SET_CONTROLS
	;disable graphics on layer 0
	LDA	$9F29
	AND	#%00000111
	ORA	#%01100000
	STA	$9F29	;enable layer 0
	JSR	STOP_MUSIC
	JMP	INIT_GAME
EXEC1:	CMP	#2	;DIFF LEVEL
	BNE	EXEC05
	INC	DIFF_LEVEL
	LDA	DIFF_LEVEL
	CMP	#3
	BNE	EXEC02
	LDA	#0
	STA	DIFF_LEVEL
EXEC02:	JSR	CHANGE_DIFFICULTY_LEVEL
	JMP	ISLOOP
EXEC05:	CMP	#1	;cycle map
	BNE	EXEC06
	JSR	CYCLE_MAP
EXEC06:	CMP	#3
	BNE	EXEC07
	JSR	CYCLE_CONTROLS
EXEC07:	JMP	ISLOOP

CYCLE_CONTROLS:
	LDA	#0
	STA	KEYS_DEFINED
	INC	CONTROL
	LDA	CONTROL
	CMP	#3
	BNE	CCON2
	LDA	#0
	STA	CONTROL
CCON2:	;display control method on screen
	LDA	#%00100000
	STA	VERA_H
	LDA	#05
	STA	VERA_M
	LDA	#08
	STA	VERA_L
	LDY	CONTROL
	LDA	CONTROLSTART,Y
	TAY
	LDX	#0
CCON3:	LDA	CONTROLTEXT,Y
	STA	VERA_DATA
	INX
	INY
	CPX	#10
	BNE	CCON3
	RTS

CONTROLTEXT:	!SCR"keyboard  "
		!SCR"custom key"
		!SCR"snes pad  "
CONTROLSTART:	!BYTE 00,10,20

CYCLE_MAP:
	INC	SELECTED_MAP
	LDA	SELECTED_MAP
	CMP	#14	;MAXIMUM MAP NUMBER
	BNE	CYM1
	LDA	#0
	STA	SELECTED_MAP
CYM1:	JSR	DISPLAY_MAP_NAME
	RTS

DISPLAY_MAP_NAME:
	LDA	#%00100000
	STA	VERA_H
	LDA	#8
	STA	VERA_M
	LDA	#2
	STA	VERA_L
	JSR	CALC_MAP_NAME
DMN1:	LDA	($02),Y
	STA	VERA_DATA
	INY
	CPY	#16
	BNE	DMN1
	;now set the mapname for the filesystem load
	LDA	SELECTED_MAP
	CLC
	ADC	#65
	STA	MAPNAME+6
	RTS

CALC_MAP_NAME:
	;FIND MAP NAME
	LDA	SELECTED_MAP
	STA	$02
	LDA	#0
	STA	$03
	;multiply by 16 by shifting 4 times to left.
	ASL	$02
	ROL	$03
	ASL	$02
	ROL	$03
	ASL	$02
	ROL	$03
	ASL	$02
	ROL	$03
	;now add offset for mapnames
	LDA	$02
	CLC
	ADC	#<MAP_NAMES
	STA	$02
	LDA	$03
	ADC	#>MAP_NAMES
	STA	$03
	LDY	#0
	RTS

UPDATE_MENU_FLASH:
	LDY	SPRITECOLSTATE
	LDA	SPRITECOLCHART,Y
	STA	MENUCOL
	JSR	FLASH_MENU_OPTION
	RTS

FLASH_MENU_OPTION:
	LDA	MENUY
	CLC
	ADC	#02
	STA	VERA_M
	LDA	#9
	STA	VERA_L
	LDA	#%00100000
	STA	VERA_H
	LDA	MENUCOL
	LDX	#0
RMO1:	STA	VERA_DATA
	INX
	CPX	#10
	BNE	RMO1
	RTS
MENUY	!BYTE	$00	;CURRENT MENU SELECTION
MENUCOL	!BYTE	$00	;COLOR TO PAINT MENU LINE.

CHANGE_DIFFICULTY_LEVEL:
	;coordinates of face is 234, 95		
	LDA	#%00010000
	STA	VERA_H
	;let's find our starting point in the data
	;based on the diffulty level, and set it to X
	LDX	DIFF_LEVEL
	LDA	FACE_X_CHART,X
	TAX
	;now draw the face.
	LDY	#0
CDL01:	LDA	FACE_Y_CHART_H,Y
	STA	VERA_M
	LDA	FACE_Y_CHART_L,Y
	STA	VERA_L
	LDA	THREE_FACES,X
	STA	VERA_DATA
	INX
	LDA	THREE_FACES,X
	STA	VERA_DATA
	INX
	LDA	THREE_FACES,X
	STA	VERA_DATA
	INX
	LDA	THREE_FACES,X
	STA	VERA_DATA
	INX
	LDA	THREE_FACES,X
	STA	VERA_DATA
	INX
	LDA	THREE_FACES,X
	STA	VERA_DATA
	INX
	LDA	THREE_FACES,X
	STA	VERA_DATA
	INX
	LDA	THREE_FACES,X
	STA	VERA_DATA
	INX
	INY
	CPY	#10
	BNE	CDL01
	RTS

;This chart contains the high and low values of each of the 10
;lines on the screen where the face starts.

FACE_Y_CHART_H:
	!BYTE	$4F,$4F,$50,$51,$51,$52,$53,$53,$54,$54
FACE_Y_CHART_L:
	!BYTE	$55,$F5,$95,$35,$D5,$75,$15,$B5,$55,$F5
FACE_X_CHART:
	!BYTE	0,80,160

DIFF_LEVEL	!BYTE 1

DISPLAY_INTRO_SCREEN:
	JSR	LOAD_TITLE_SCREEN
	JSR	GREEN_SCREEN
	;first do text part
	LDA	#<INTRO_TEXT
	STA	SOURCE_L
	LDA	#>INTRO_TEXT
	STA	SOURCE_H
	LDA	#00
	STA	EVENODD
	JSR	DECOMPRESS_SCREEN	;Decompress text characters
	;now enable graphics on layer 0 and text on layer 1
	LDA	$9F29
	ORA	#%00110000
	STA	$9F29	;enable layer 0 and 1
	LDA	#6
	STA	$9F2D	;set layer 0 to bitmap mode 4BPP
	LDA	#16
	STA	$9F2F	;set base address for bitmap
	LDA	#01	;set palette #1	
	STA	$9F31
	RTS