DRAW_MAP_SPRITES:	;(sprites 3-34)
	LDX	#0
	LDA	#%00010001
	STA	VERA_H
	LDA	#$FC
	STA	VERA_M
	LDA	#$18
	STA	VERA_L
SPRLP:	LDA	UNIT_TYPE,X
	CMP	#0	;Does it exist?
	BNE	SPR2
SPOFF:	;disable sprite
	LDY	VERA_DATA
	LDY	VERA_DATA
	LDY	VERA_DATA
	LDY	VERA_DATA
	LDY	VERA_DATA
	LDY	VERA_DATA
	STZ	VERA_DATA
	LDY	VERA_DATA	
	JMP	SPRNXT
SPR2:	;is it on-screen?
	;check horizontal
	LDA	MAP_WINDOW_X
	CMP	UNIT_LOC_X,X
	BCC	SPR3
	BEQ	SPR3
	JMP	SPOFF
SPR3:	CLC
	ADC	#10
	CMP	UNIT_LOC_X,X
	BCS	SPR4
	JMP	SPOFF
SPR4:	;Now check veritcal
	LDA	MAP_WINDOW_Y
	CMP	UNIT_LOC_Y,X
	BCC	SPR5
	BEQ	SPR5
	JMP	SPOFF
SPR5:	CLC
	ADC	#6
	CMP	UNIT_LOC_Y,X
	BCS	SPRON
	JMP	SPOFF
SPRON:	;enable sprite and configure it.
	LDA	UNIT_TILE,X
	STZ	TEMP_A
	ASL
	ROL	TEMP_A
	ASL	
	ROL	TEMP_A
	ASL	
	ROL	TEMP_A
	ASL	
	ROL	TEMP_A
	CLC
	STA	VERA_DATA	;sprite addr L
	LDA	TEMP_A
	ORA	#%00001000
	STA	VERA_DATA	;sprite addr H
	STZ	TEMP_A
	LDA	UNIT_LOC_X,X
	SEC
	SBC	MAP_WINDOW_X
	TAY
	LDA	SPRITE_X_TABLE,Y
	STA	VERA_DATA	;sprite XL
	STZ	VERA_DATA	;sprite XH
	LDA	UNIT_LOC_Y,X
	SEC
	SBC	MAP_WINDOW_Y
	TAY
	LDA	SPRITE_Y_TABLE,Y
	STA	VERA_DATA	;sprite YL
	STZ	VERA_DATA	;sprite YH
	LDA	#12
	STA	VERA_DATA	;Z-depth
	LDA	#%10100011
	STA	VERA_DATA	;h/w/palette
SPRNXT:	INX
	CPX	#32
	BEQ	SPREND
	JMP	SPRLP
SPREND:	RTS
	RTS

SPRITE_X_TABLE:
	!BYTE	$00	;0
	!BYTE	$18	;1
	!BYTE	$30	;2
	!BYTE	$48	;3
	!BYTE	$60	;4
	!BYTE	$78	;5
	!BYTE	$90	;6
	!BYTE	$A8	;7
	!BYTE	$C0	;8
	!BYTE	$D8	;9
	!BYTE	$F0	;10

SPRITE_Y_TABLE:
	!BYTE	$10	;0
	!BYTE	$28	;1
	!BYTE	$40	;2
	!BYTE	$58	;3
	!BYTE	$70	;4
	!BYTE	$88	;5
	!BYTE	$A0	;6

;This routine is where the MAP is displayed on the screen
;This is a temporary routine, taken from the map editor.
DRAW_MAP_WINDOW:
	JSR	MAP_PRE_CALCULATE
	LDA	#0
	STA	REDRAW_WINDOW
	STA	TEMP_X
	STA	TEMP_Y
	LDX	#0
DM01:	;now calculate where on the screen the tile will go
	LDA	#%00010000
	STA	VERA_H
	LDX	TEMP_Y
	LDA	Y_TILE,X
	STA	VERA_M
	LDX	TEMP_X
	LDA	X_TILE,X
	STA	VERA_L
	;Render screen based on precalc buffer
	LDX	TEMP_Y
	LDA	PRECALC_ROWS,X
	CLC
	ADC	TEMP_X
	TAX
	LDA	MAP_PRECALC,X
	CMP	MAP_LASTCALC,X
	BEQ	DM05
	JSR	PLOT_TILE
	;Now continue the loop
DM05:	INC	TEMP_X
	LDA	TEMP_X
	CMP	#11	
	BNE	DM01
	STZ	TEMP_X
	INC	TEMP_Y
	LDA	TEMP_Y
	CMP	#7
	BNE	DM01
DM10:	JSR	DRAW_MAP_SPRITES
	JSR	COPY_BUFFER
	RTS

Y_TILE:	!BYTE $2A,$39,$48,$57,$66,$75,$84
X_TILE:	!BYTE 0,12,24,36,48,60,72,84,96,108,120

COPY_BUFFER:
	LDX	#0
CPBU1:	LDA	MAP_PRECALC,X
	STA	MAP_LASTCALC,X
	INX
	CPX	#77
	BNE	CPBU1
	RTS

CLEAR_LASTCALC:
	LDX	#0
	LDA	#255
CLBU1:	STA	MAP_LASTCALC,X
	INX
	CPX	#77
	BNE	CLBU1
	RTS

MAP_PRE_CALCULATE:
	STZ	TEMP_Y
	LDX	#0
PREC1:	LDY	#0
	LDA	TEMP_Y
	CLC
	ADC	MAP_WINDOW_Y
	ROR
	PHP
	CLC
	ADC	#>MAP
	STA	SOURCE_H	;HIGH BYTE OF MAP SOURCE
	LDA	#$0
	PLP
	ROR
	CLC
	ADC	MAP_WINDOW_X
	STA	SOURCE_L	;LOW BYTE OF MAP SOURCE
	;now start copying to precalc buffer
PREC2:	LDA	(SOURCE_L),Y
	STA	MAP_PRECALC,X
	INX
	INY
	CPY	#11
	BNE	PREC2
	INC	TEMP_Y
	LDA	TEMP_Y
	CMP	#7
	BNE	PREC1
	RTS

PRECALC_ROWS:	!BYTE	0,11,22,33,44,55,66

PLOT_TILE:
	TAX
	LDA	TILE_BANK,X
	STA	RAM_BANK
	LDA	TILE_L,X
	STA	SOURCE_L
	LDA	TILE_H,X
	STA	SOURCE_H
	LDY	#0
	LDX	#0
PLTL3:	;copy 12 bytes to vera
	LDA	(SOURCE_L),Y	;Urolled loop for extra copy speed
	STA	VERA_DATA
	INY
	LDA	(SOURCE_L),Y
	STA	VERA_DATA
	INY
	LDA	(SOURCE_L),Y
	STA	VERA_DATA
	INY
	LDA	(SOURCE_L),Y
	STA	VERA_DATA
	INY
	LDA	(SOURCE_L),Y
	STA	VERA_DATA
	INY
	LDA	(SOURCE_L),Y
	STA	VERA_DATA
	INY
	LDA	(SOURCE_L),Y
	STA	VERA_DATA
	INY
	LDA	(SOURCE_L),Y
	STA	VERA_DATA
	INY
	LDA	(SOURCE_L),Y
	STA	VERA_DATA
	INY
	LDA	(SOURCE_L),Y
	STA	VERA_DATA
	INY
	LDA	(SOURCE_L),Y
	STA	VERA_DATA
	INY
	LDA	(SOURCE_L),Y
	STA	VERA_DATA
	INX
	CPX	#24
	BEQ	PLTL6
	INY	
	LDY	#0
	;Increase source location by 12
	LDA	SOURCE_L
	CLC
	ADC	#12
	STA	SOURCE_L
	BCC	PLTL4
	INC	SOURCE_H
PLTL4:	;increase vera screen ram target by 148
	LDA	VERA_L
	CLC
	ADC	#148
	STA	VERA_L
	BCC	PLTL3
	INC	VERA_M
	JMP	PLTL3
PLTL6:	RTS

;This routine originally reversed the tiles on the PET version,
;but here on the X16 instead it turns on the appropriate sprite
REVERSE_TILE:
	LDA	#%00010001
	STA	VERA_H
	LDA	#$FC
	STA	VERA_M
	LDA	CURSOR_ON
	CMP	#0
	BEQ	REV2
	;Determine which cursor image to show
	LDA	#16	;sprite 33 addresss high
	STA	VERA_L
	LDX	CURSOR_ON
	LDA	CURSOR_TABLE, X
	STA	VERA_DATA
	;Set X-position
	LDA	#18	;sprite 33 X position
	STA	VERA_L
	LDA	CURSOR_X
	SEC
	SBC	#4
	TAX
	LDA	X_CURSOR_TABLE,X
	STA	VERA_DATA
	;Set Y-position
	LDA	#20	;sprite 33 X position
	STA	VERA_L
	LDA	CURSOR_Y
	SEC
	SBC	#2
	TAX
	LDA	Y_CURSOR_TABLE,X
	STA	VERA_DATA
	;Enable sprite
	LDA	#22	;sprite 33 z-depth
	STA	VERA_L
	LDA	#%00001100	;enable sprite
	STA	VERA_DATA
	RTS
REV2:	;Turn off cursor sprite
	LDA	#22	;sprite 33 z-depth
	STA	VERA_L
	LDA	#%00000000	;enable sprite
	STA	VERA_DATA
	RTS

CURSOR_TABLE	!BYTE $40,$40,$50,$60	;cursor image
X_CURSOR_TABLE	!BYTE 98,122,146	;cursor position
Y_CURSOR_TABLE	!BYTE 65,89,113		;cursor position

;This routine checks to see if UNIT is occupying any space
;that is currently visible in the window.  If so, the
;flag for redrawing the window will be set.
CHECK_FOR_WINDOW_REDRAW:
	LDX	UNIT
	;FIRST CHECK HORIZONTAL
	LDA	UNIT_LOC_X,X
	CMP	MAP_WINDOW_X
	BCC	CFR1
	LDA	MAP_WINDOW_X
	CLC
	ADC	#10
	CMP	UNIT_LOC_X,X
	BCC	CFR1
	;NOW CHECK VERTICAL
	LDA	UNIT_LOC_Y,X
	CMP	MAP_WINDOW_Y
	BCC	CFR1
	LDA	MAP_WINDOW_Y
	CLC
	ADC	#6
	CMP	UNIT_LOC_Y,X
	BCC	CFR1
	LDA	#1
	STA	REDRAW_WINDOW
CFR1:	RTS

DISPLAY_PLAYER_SPRITE:
	LDA	PLAYER_DIRECTION
	CLC
	ADC	PLAYER_ANIMATE
	LDX	SELECTED_WEAPON
	ADC	WEAPON_OFFSET,X
	STA 	UNIT_TILE
	LDA	#1
	STA	REDRAW_WINDOW
DPSP4:	RTS
WEAPON_OFFSET	!BYTE 0,16,32

DISPLAY_BLANK_ITEM:
	;disable sprite #01 at $1,FC08
	LDA	#%00010001
	STA	VERA_H
	LDA	#$FC
	STA	VERA_M
	LDA	#14	;sprite z-depth
	STA	VERA_L
	LDA	#%00000000	;DISABLE sprite
	STA	VERA_DATA
	;erase quantity from screen
	LDA	#%00100000
	STA	VERA_H
	LDA	#74
	SEC
	SBC	COMPOSITE
	STA	VERA_L
	LDA	#18
	STA	VERA_M
	LDA	#32
	STA	VERA_DATA
	STA	VERA_DATA
	STA	VERA_DATA
	RTS

DISPLAY_TIMEBOMB:
	;Shown on sprite #01 at $1,FC08
	LDA	#%00010001
	STA	VERA_H
	LDA	#$FC
	STA	VERA_M
	LDA	#08	;sprite addresss high
	STA	VERA_L
	LDA	#160
	STA	VERA_DATA
	LDA	#14	;sprite z-depth
	STA	VERA_L
	LDA	#%00001100	;enable sprite
	STA	VERA_DATA
	;display QTY
	LDA	INV_BOMBS
	STA	DECNUM
	LDA	#74
	SEC
	SBC	COMPOSITE
	STA	VERA_L
	LDA	#18
	STA	VERA_M
	JSR	DECWRITE
	RTS

DISPLAY_EMP:
	;Shown on sprite #01 at $1,FC08
	LDA	#%00010001
	STA	VERA_H
	LDA	#$FC
	STA	VERA_M
	LDA	#08	;sprite addresss high
	STA	VERA_L
	LDA	#96
	STA	VERA_DATA
	LDA	#14	;sprite z-depth
	STA	VERA_L
	LDA	#%00001100	;enable sprite
	STA	VERA_DATA
	;display QTY
	LDA	INV_EMP
	STA	DECNUM
	LDA	#74
	SEC
	SBC	COMPOSITE
	STA	VERA_L
	LDA	#18
	STA	VERA_M
	JSR	DECWRITE
	RTS

DISPLAY_MEDKIT:
	;Shown on sprite #01 at $1,FC08
	LDA	#%00010001
	STA	VERA_H
	LDA	#$FC
	STA	VERA_M
	LDA	#08	;sprite addresss high
	STA	VERA_L
	LDA	#64
	STA	VERA_DATA
	LDA	#14	;sprite z-depth
	STA	VERA_L
	LDA	#%00001100	;enable sprite
	STA	VERA_DATA
	;display QTY
	LDA	INV_MEDKIT
	STA	DECNUM
	LDA	#74
	SEC
	SBC	COMPOSITE
	STA	VERA_L
	LDA	#18
	STA	VERA_M
	JSR	DECWRITE
	RTS

DISPLAY_MAGNET:
	;Shown on sprite #01 at $1,FC08
	LDA	#%00010001
	STA	VERA_H
	LDA	#$FC
	STA	VERA_M
	LDA	#08	;sprite addresss high
	STA	VERA_L
	LDA	#128
	STA	VERA_DATA
	LDA	#14	;sprite z-depth
	STA	VERA_L
	LDA	#%00001100	;enable sprite
	STA	VERA_DATA
	;display QTY
	LDA	INV_MAGNET
	STA	DECNUM
	LDA	#74
	SEC
	SBC	COMPOSITE
	STA	VERA_L
	LDA	#18
	STA	VERA_M
	JSR	DECWRITE
	RTS

DISPLAY_PLASMA_GUN:
	;Shown on sprite #00 at $1,FC00
	LDA	#%00010001
	STA	VERA_H
	LDA	#$FC
	STA	VERA_M
	LDA	#0	;sprite addresss high
	STA	VERA_L
	LDA	#32
	STA	VERA_DATA
	LDA	#06	;sprite z-depth
	STA	VERA_L
	LDA	#%00001100	;enable sprite
	STA	VERA_DATA
	;display ammo
DPG4:	LDA	AMMO_PLASMA
	STA	DECNUM
	STA	DECNUM
	LDA	#74
	SEC
	SBC	COMPOSITE
	STA	VERA_L
	LDA	#7
	STA	VERA_M
	JSR	DECWRITE
	RTS

DISPLAY_PISTOL:
	;Shown on sprite #00 at $1,FC00
	LDA	#%00010001
	STA	VERA_H
	LDA	#$FC
	STA	VERA_M
	LDA	#00	;sprite addresss high
	STA	VERA_L
	LDA	#00
	STA	VERA_DATA
	LDA	#06	;sprite z-depth
	STA	VERA_L
	LDA	#%00001100	;enable sprite
	STA	VERA_DATA
	;display ammo
	LDA	AMMO_PISTOL
	STA	DECNUM
	LDA	#74
	SEC
	SBC	COMPOSITE
	STA	VERA_L
	LDA	#7
	STA	VERA_M
	JSR	DECWRITE
	RTS

DISPLAY_BLANK_WEAPON:
	;DISABLE SPRITE	#00 at $1,FC00
	LDA	#%00010001
	STA	VERA_H
	LDA	#$FC
	STA	VERA_M
	LDA	#06	;sprite z-depth
	STA	VERA_L
	LDA	#%00000000	;disable sprite
	STA	VERA_DATA
	;ERASE QUANTITY FROM SCREEN
	LDA	#%00100000
	STA	VERA_H
	LDA	#74
	SEC
	SBC	COMPOSITE
	STA	VERA_L
	LDA	#7
	STA	VERA_M
	LDA	#32
	STA	VERA_DATA
	STA	VERA_DATA
	STA	VERA_DATA
	RTS

DISPLAY_KEYS:
	;ERASE ALL 3 SPOTS
	LDX	#%00010000
	STX	VERA_H
	LDX	#24
	STX	VERA_M
	LDX	#68
	STX	VERA_L
	LDA	#32
	STA	VERA_DATA	;TEXT
	LDX	#02	;RED
	STX	VERA_DATA	;COLOR
	STA	VERA_DATA	;TEXT
	STX	VERA_DATA	;COLOR
	STA	VERA_DATA	;TEXT
	LDX	#05	;GREEN
	STX	VERA_DATA	;COLOR
	STA	VERA_DATA	;TEXT
	STX	VERA_DATA	;COLOR	
	STA	VERA_DATA	;TEXT
	LDX	#06	;BLUE
	STX	VERA_DATA	;COLOR
	STA	VERA_DATA	;TEXT
	STX	VERA_DATA	;COLOR
	LDX	#25
	STX	VERA_M
	LDX	#68
	STX	VERA_L
	STA	VERA_DATA	;TEXT
	LDX	#02	;RED
	STX	VERA_DATA	;COLOR
	STA	VERA_DATA	;TEXT
	STX	VERA_DATA	;COLOR
	STA	VERA_DATA	;TEXT
	LDX	#05	;GREEN
	STX	VERA_DATA	;COLOR
	STA	VERA_DATA	;TEXT
	STX	VERA_DATA	;COLOR	
	STA	VERA_DATA	;TEXT
	LDX	#06	;BLUE
	STX	VERA_DATA	;COLOR
	STA	VERA_DATA	;TEXT
	STX	VERA_DATA	;COLOR
	LDX	#%00100000
	STX	VERA_H
	;DRAW KEYS
	LDA	KEYS
	AND	#%00000001
	CMP	#%00000001	;Spade key
	BNE	DKS1
	LDX	#24
	STX	VERA_M
	LDX	#68
	STX	VERA_L
	LDA	#$63
	STA	VERA_DATA
	LDA	#$4D
	STA	VERA_DATA
	LDX	#25
	STX	VERA_M
	LDX	#68
	STX	VERA_L
	LDA	#$41
	STA	VERA_DATA
	LDA	#$67
	STA	VERA_DATA
DKS1:	LDA	KEYS
	AND	#%00000010
	CMP	#%00000010	;heart key
	BNE	DKS2
	LDX	#24
	STX	VERA_M
	LDX	#72
	STX	VERA_L
	LDA	#$63
	STA	VERA_DATA
	LDA	#$4D
	STA	VERA_DATA
	LDX	#25
	STX	VERA_M
	LDX	#72
	STX	VERA_L
	LDA	#$53
	STA	VERA_DATA
	LDA	#$67
	STA	VERA_DATA
DKS2:	LDA	KEYS
	AND	#%00000100
	CMP	#%00000100	;star key
	BNE	DKS3
	LDX	#24
	STX	VERA_M
	LDX	#76
	STX	VERA_L
	LDA	#$63
	STA	VERA_DATA
	LDA	#$4D
	STA	VERA_DATA
	LDX	#25
	STX	VERA_M
	LDX	#76
	STX	VERA_L
	LDA	#$2A
	STA	VERA_DATA
	LDA	#$67
	STA	VERA_DATA
DKS3:	RTS

DISABLE_SPRITES:
	LDA	#%00010001
	STA	VERA_H
	LDA	#$06
	STA	TEMP_B	;LOW
	LDA	#$FC
	STA	TEMP_A	;HIGH
	LDX	#0
DISA2:	LDA	TEMP_A
	STA	VERA_M
	LDA	TEMP_B	
	STA	VERA_L
	LDA	#%00000000	;DISABLE sprite
	STA	VERA_DATA
	;now add 8 to it.
	LDA	TEMP_B
	CLC
	ADC	#$08
	STA	TEMP_B
	BCC	DISA3
	INC	TEMP_A
DISA3:	INX
	CPX	#35
	BNE	DISA2
	RTS

;Setup sprites # 0-1 for weapons/items and 2 for cursors
INIT_SPRITES:
	LDA	#%00010001
	STA	VERA_H
	LDA	#$FC
	STA	VERA_M
	LDA	#00
	STA	VERA_L
	LDX	#0
INTSP1:	LDA	SPRITE_ATTRIB,X
	STA	VERA_DATA
	INX
	CPX	#32
	BNE	INTSP1
	LDA	$9F29		;DCVIDEO REGISTER
	ORA	#%01000000	;enable sprites
	STA	$9F29
	RTS
SPRITE_ATTRIB:
	;SPRITE 0	(weapons display)
	!BYTE	%00000000	;ADDRESS 12:5
	!BYTE	%00000111	;MODE (BIT 7) ADRESS 16:13 (BITS 3:0)
	!BYTE	07		;X 7:0
	!BYTE	%00000001	;X 9:8
	!BYTE	24		;Y 7:0
	!BYTE	%00000000	;Y 9:8
	!BYTE	%00000000	;COLLISION MASK, Z-DEPTH, V-FLIP,H-FLIP
	!BYTE	%10110000	;HEIGHT, WIDTH, PALETTE OFFSET (BITS 3:0)
	;SPRITE 1	(items display)
	!BYTE	%01100000	;ADDRESS 12:5
	!BYTE	%00000111	;MODE (BIT 7) ADRESS 16:13 (BITS 3:0)
	!BYTE	07		;X 7:0
	!BYTE	%00000001	;X 9:8
	!BYTE	114		;Y 7:0
	!BYTE	%00000000	;Y 9:8
	!BYTE	%00000000	;COLLISION MASK, Z-DEPTH, V-FLIP,H-FLIP
	!BYTE	%10110000	;HEIGHT, WIDTH, PALETTE OFFSET (BITS 3:0)
	;SPRITE 2	(cursors)
	!BYTE	%00000000	;ADDRESS 12:5
	!BYTE	$0E		;MODE (BIT 7) ADRESS 16:13 (BITS 3:0)
	!BYTE	122		;X 7:0
	!BYTE	%00000000	;X 9:8
	!BYTE	89		;Y 7:0
	!BYTE	%00000000	;Y 9:8
	!BYTE	%00000000	;COLLISION MASK, Z-DEPTH, V-FLIP,H-FLIP
	!BYTE	%10100011	;HEIGHT, WIDTH, PALETTE OFFSET (BITS 3:0)
	
SET_INITIAL_UNIT_SPRITES:
	STZ	PLAYER_DIRECTION
	STZ	PLAYER_ANIMATE
	JSR	DISPLAY_PLAYER_SPRITE
	LDX	#1
	LDY	#0
SIUS0:	LDA	UNIT_TYPE,X
SIUS1:	CMP	INIT_UT,Y
	BEQ	SIUS3
	INY
	CPY	#8
	BNE	SIUS1
SIUS2:	LDY	#0
	INX
	CPX	#28	;max units
	BNE	SIUS0
	RTS
SIUS3:	LDA	INIT_SP,Y
	STA	UNIT_TILE,X
	JMP	SIUS2

INIT_UT	!BYTE 01,02,03,04,05,09,17,18
INIT_SP !BYTE 00,56,56,56,56,60,48,48

SETUP_VERA:
	;Check for composite vs vga
	LDA	$9F29
	AND	#%00000011
	CMP	#01
	BNE	SETV1
	;VGA MODE - switch to 40 column mode.
	LDA	#64
	STA	$9F2A	;VERA H-SCALE
	STA	$9F2B	;VERA V-SCALE
	JMP	SETGFX
SETV1:	;composite mode
	LDA	#6
	STA	COMPOSITE
	LDA	#70
	STA	$9F2A	;VERA H-SCALE
	LDA	#69
	STA	$9F2B	;VERA V-SCALE
	LDA	#0
	STA	$9F2C	;set border to black
	SEI
	LDA	#%00000010
	STA	$9F25	;enable DC select
	LDA	#9
	STA	$9F29	;H-START
	LDA	#155	
	STA	$9F2A	;H-STOP
	LDA	#7	
	STA	$9F2B	;V-START
	LDA	#230	
	STA	$9F2C	;V-STOP	
	LDA	#%00000000
	STA	$9F25	;disable DC select
	CLI
	LDA	$9F29		;clear 240p mode
	AND	#%11110111	;clear 240p mode
	STA	$9F29		;clear 240p mode
	;modify screen shake variables
	LDA	#09
	STA	SHAKE5+1
	LDX	#0
SETV1A:	LDA	CSCRSHAKE,X
	STA	SSHAKE,X
	INX
	CPX	#5
	BNE	SETV1A
SETGFX:	;configure gfx modes
	LDA	#$A0
	STA	$9F34	;set layer 1 (text mode)
	LDA	#0
	STA	$9F35	;set text mode vram base address to $0000
	LDA	#$7C
	STA	$9F36	;SET character bitmap vram location to $F800
	;NOW COPY MODIFIED PALETTES
	LDA	#%00010001
	STA	VERA_H
	LDA	#$FA
	STA	VERA_M
	LDA	#00
	STA	VERA_L
	LDY	#0
SETV2:	LDX	#0
SETV3:	LDA	PALETTE,X
	STA	VERA_DATA
	INX
	CPX	#128
	BNE	SETV3
	RTS

CSCRSHAKE	!BYTE 9,10,11,10,9

SCREEN_FLASHER:
	;DAMAGE FLASHER
	LDX	DMGFLASH
	CPX	#0
	BEQ	SCFL3
	LDA	DMGTABLE,X
	LDX	#%00000001
	STX	VERA_H
	LDX	#$FA
	STX	VERA_M
	LDX	#$01
	STX	VERA_L
	STA	VERA_DATA
	DEC	DMGFLASH
SCFL3:	;EMP FLASHER
	LDX	EMPFLASH
	CPX	#0
	BEQ	SCFL4
	LDA	EMPTABLE,X
	LDX	#%00000001
	STX	VERA_H
	LDX	#$FA
	STX	VERA_M
	LDX	#$00
	STX	VERA_L
	STA	VERA_DATA	
	DEC	EMPFLASH
SCFL4:	;SCREEN_SHAKER
	LDA	SCREEN_SHAKE
	CMP	#$00
	BEQ	SHAKE4
SHAKE2:	INC	SSCOUNT
	LDA	SSCOUNT
	CMP	#5
	BNE	SHAKE3
	LDA	#0
	STA	SSCOUNT
SHAKE3:	LDY	#2
	STY	$9F25
	LDY	SSCOUNT
	LDA	SSHAKE,Y
	STA	$9F29
	STZ	$9F25
	RTS
SHAKE4:	;set screen back to normal
	LDA	#02
	STA	$9F25
SHAKE5:	LDA	#0
	STA	$9F29
	STZ	$9F25
	RTS

DMGTABLE	!BYTE 00,00,8,10,12,14,16,12,10,8
EMPTABLE	!BYTE 00,00,8,15,79,159,159,79,15,15,08
DMGFLASH	!BYTE 00
EMPFLASH	!BYTE 00
SSHAKE		!BYTE 00,01,02,01,00
SSCOUNT		!BYTE 00
	
